/* CategoryItem.c generated by valac 0.43.4, the Vala compiler
 * generated from CategoryItem.vala, do not modify */

/*-
 * Copyright (c) 2017 Adam Bieńkowski
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <granite.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define APP_EDITOR_TYPE_CATEGORY_ITEM (app_editor_category_item_get_type ())
#define APP_EDITOR_CATEGORY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_EDITOR_TYPE_CATEGORY_ITEM, AppEditorCategoryItem))
#define APP_EDITOR_CATEGORY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_EDITOR_TYPE_CATEGORY_ITEM, AppEditorCategoryItemClass))
#define APP_EDITOR_IS_CATEGORY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_EDITOR_TYPE_CATEGORY_ITEM))
#define APP_EDITOR_IS_CATEGORY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_EDITOR_TYPE_CATEGORY_ITEM))
#define APP_EDITOR_CATEGORY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_EDITOR_TYPE_CATEGORY_ITEM, AppEditorCategoryItemClass))

typedef struct _AppEditorCategoryItem AppEditorCategoryItem;
typedef struct _AppEditorCategoryItemClass AppEditorCategoryItemClass;
typedef struct _AppEditorCategoryItemPrivate AppEditorCategoryItemPrivate;

#define TYPE_APP_CATEGORY (app_category_get_type ())
typedef struct _AppCategory AppCategory;
enum  {
	APP_EDITOR_CATEGORY_ITEM_0_PROPERTY,
	APP_EDITOR_CATEGORY_ITEM_CATEGORY_PROPERTY,
	APP_EDITOR_CATEGORY_ITEM_NUM_PROPERTIES
};
static GParamSpec* app_editor_category_item_properties[APP_EDITOR_CATEGORY_ITEM_NUM_PROPERTIES];

struct _AppEditorCategoryItem {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	AppEditorCategoryItemPrivate * priv;
};

struct _AppEditorCategoryItemClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _AppCategory {
	gchar* id;
	const gchar* name;
	gchar* icon_name;
};

struct _AppEditorCategoryItemPrivate {
	AppCategory _category;
};

static gint AppEditorCategoryItem_private_offset;
static gpointer app_editor_category_item_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * app_editor_category_item_granite_widgets_source_list_sortable_parent_iface = NULL;

GType app_editor_category_item_get_type (void) G_GNUC_CONST;
GType app_category_get_type (void) G_GNUC_CONST;
AppCategory* app_category_dup (const AppCategory* self);
void app_category_free (AppCategory* self);
void app_category_copy (const AppCategory* self,
                        AppCategory* dest);
void app_category_destroy (AppCategory* self);
AppEditorCategoryItem* app_editor_category_item_new (AppCategory* category);
AppEditorCategoryItem* app_editor_category_item_construct (GType object_type,
                                                           AppCategory* category);
static gboolean app_editor_category_item_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint app_editor_category_item_real_compare (GraniteWidgetsSourceListSortable* base,
                                            GraniteWidgetsSourceListItem* a,
                                            GraniteWidgetsSourceListItem* b);
void app_editor_category_item_get_category (AppEditorCategoryItem* self,
                                            AppCategory * result);
static void app_editor_category_item_set_category (AppEditorCategoryItem* self,
                                            AppCategory * value);
static gboolean _app_category_equal (const AppCategory * s1,
                              const AppCategory * s2);
static void app_editor_category_item_finalize (GObject * obj);
static void _vala_app_editor_category_item_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_app_editor_category_item_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
app_editor_category_item_get_instance_private (AppEditorCategoryItem* self)
{
	return G_STRUCT_MEMBER_P (self, AppEditorCategoryItem_private_offset);
}

AppEditorCategoryItem*
app_editor_category_item_construct (GType object_type,
                                    AppCategory* category)
{
	AppEditorCategoryItem * self = NULL;
	AppCategory _tmp0_;
	AppCategory _tmp1_;
	const gchar* _tmp2_;
#line 23 "../src/CategoryItem.vala"
	g_return_val_if_fail (category != NULL, NULL);
#line 24 "../src/CategoryItem.vala"
	_tmp0_ = *category;
#line 24 "../src/CategoryItem.vala"
	_tmp1_ = *category;
#line 24 "../src/CategoryItem.vala"
	_tmp2_ = _tmp1_.name;
#line 24 "../src/CategoryItem.vala"
	self = (AppEditorCategoryItem*) g_object_new (object_type, "category", &_tmp0_, "name", _tmp2_, NULL);
#line 23 "../src/CategoryItem.vala"
	return self;
#line 129 "CategoryItem.c"
}

AppEditorCategoryItem*
app_editor_category_item_new (AppCategory* category)
{
#line 23 "../src/CategoryItem.vala"
	return app_editor_category_item_construct (APP_EDITOR_TYPE_CATEGORY_ITEM, category);
#line 137 "CategoryItem.c"
}

static gboolean
app_editor_category_item_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	AppEditorCategoryItem * self;
	gboolean result = FALSE;
#line 30 "../src/CategoryItem.vala"
	self = (AppEditorCategoryItem*) base;
#line 31 "../src/CategoryItem.vala"
	result = FALSE;
#line 31 "../src/CategoryItem.vala"
	return result;
#line 151 "CategoryItem.c"
}

static gint
app_editor_category_item_real_compare (GraniteWidgetsSourceListSortable* base,
                                       GraniteWidgetsSourceListItem* a,
                                       GraniteWidgetsSourceListItem* b)
{
	AppEditorCategoryItem * self;
	gint result = 0;
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 34 "../src/CategoryItem.vala"
	self = (AppEditorCategoryItem*) base;
#line 34 "../src/CategoryItem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 34 "../src/CategoryItem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 35 "../src/CategoryItem.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 35 "../src/CategoryItem.vala"
	_tmp1_ = granite_widgets_source_list_item_get_name (a);
#line 35 "../src/CategoryItem.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/CategoryItem.vala"
	_tmp3_ = granite_widgets_source_list_item_get_name (b);
#line 35 "../src/CategoryItem.vala"
	_tmp4_ = _tmp3_;
#line 35 "../src/CategoryItem.vala"
	result = _tmp0_ (_tmp2_, _tmp4_);
#line 35 "../src/CategoryItem.vala"
	return result;
#line 186 "CategoryItem.c"
}

void
app_editor_category_item_get_category (AppEditorCategoryItem* self,
                                       AppCategory * result)
{
	AppCategory _tmp0_;
#line 21 "../src/CategoryItem.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/CategoryItem.vala"
	_tmp0_ = self->priv->_category;
#line 21 "../src/CategoryItem.vala"
	*result = _tmp0_;
#line 21 "../src/CategoryItem.vala"
	return;
#line 202 "CategoryItem.c"
}

static gboolean
_app_category_equal (const AppCategory * s1,
                     const AppCategory * s2)
{
#line 21 "../src/CategoryItem.vala"
	if (s1 == s2) {
#line 21 "../src/CategoryItem.vala"
		return TRUE;
#line 213 "CategoryItem.c"
	}
#line 21 "../src/CategoryItem.vala"
	if (s1 == NULL) {
#line 21 "../src/CategoryItem.vala"
		return FALSE;
#line 219 "CategoryItem.c"
	}
#line 21 "../src/CategoryItem.vala"
	if (s2 == NULL) {
#line 21 "../src/CategoryItem.vala"
		return FALSE;
#line 225 "CategoryItem.c"
	}
#line 21 "../src/CategoryItem.vala"
	if (g_strcmp0 (s1->id, s2->id)) {
#line 21 "../src/CategoryItem.vala"
		return FALSE;
#line 231 "CategoryItem.c"
	}
#line 21 "../src/CategoryItem.vala"
	if (g_strcmp0 (s1->name, s2->name)) {
#line 21 "../src/CategoryItem.vala"
		return FALSE;
#line 237 "CategoryItem.c"
	}
#line 21 "../src/CategoryItem.vala"
	if (g_strcmp0 (s1->icon_name, s2->icon_name)) {
#line 21 "../src/CategoryItem.vala"
		return FALSE;
#line 243 "CategoryItem.c"
	}
#line 21 "../src/CategoryItem.vala"
	return TRUE;
#line 247 "CategoryItem.c"
}

static void
app_editor_category_item_set_category (AppEditorCategoryItem* self,
                                       AppCategory * value)
{
	AppCategory old_value;
#line 21 "../src/CategoryItem.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/CategoryItem.vala"
	if (_app_category_equal (value, (app_editor_category_item_get_category (self, &old_value), &old_value)) != TRUE) {
#line 259 "CategoryItem.c"
		AppCategory _tmp0_;
		AppCategory _tmp1_ = {0};
#line 21 "../src/CategoryItem.vala"
		_tmp0_ = *value;
#line 21 "../src/CategoryItem.vala"
		app_category_copy (&_tmp0_, &_tmp1_);
#line 21 "../src/CategoryItem.vala"
		app_category_destroy (&self->priv->_category);
#line 21 "../src/CategoryItem.vala"
		self->priv->_category = _tmp1_;
#line 21 "../src/CategoryItem.vala"
		g_object_notify_by_pspec ((GObject *) self, app_editor_category_item_properties[APP_EDITOR_CATEGORY_ITEM_CATEGORY_PROPERTY]);
#line 272 "CategoryItem.c"
	}
}

static void
app_editor_category_item_class_init (AppEditorCategoryItemClass * klass,
                                     gpointer klass_data)
{
#line 20 "../src/CategoryItem.vala"
	app_editor_category_item_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/CategoryItem.vala"
	g_type_class_adjust_private_offset (klass, &AppEditorCategoryItem_private_offset);
#line 20 "../src/CategoryItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_editor_category_item_get_property;
#line 20 "../src/CategoryItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_editor_category_item_set_property;
#line 20 "../src/CategoryItem.vala"
	G_OBJECT_CLASS (klass)->finalize = app_editor_category_item_finalize;
#line 20 "../src/CategoryItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_EDITOR_CATEGORY_ITEM_CATEGORY_PROPERTY, app_editor_category_item_properties[APP_EDITOR_CATEGORY_ITEM_CATEGORY_PROPERTY] = g_param_spec_boxed ("category", "category", "category", TYPE_APP_CATEGORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 292 "CategoryItem.c"
}

static void
app_editor_category_item_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface,
                                                                              gpointer iface_data)
{
#line 20 "../src/CategoryItem.vala"
	app_editor_category_item_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../src/CategoryItem.vala"
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable*)) app_editor_category_item_real_allow_dnd_sorting;
#line 20 "../src/CategoryItem.vala"
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable*, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) app_editor_category_item_real_compare;
#line 305 "CategoryItem.c"
}

static void
app_editor_category_item_instance_init (AppEditorCategoryItem * self,
                                        gpointer klass)
{
#line 20 "../src/CategoryItem.vala"
	self->priv = app_editor_category_item_get_instance_private (self);
#line 314 "CategoryItem.c"
}

static void
app_editor_category_item_finalize (GObject * obj)
{
	AppEditorCategoryItem * self;
#line 20 "../src/CategoryItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_EDITOR_TYPE_CATEGORY_ITEM, AppEditorCategoryItem);
#line 21 "../src/CategoryItem.vala"
	app_category_destroy (&self->priv->_category);
#line 20 "../src/CategoryItem.vala"
	G_OBJECT_CLASS (app_editor_category_item_parent_class)->finalize (obj);
#line 327 "CategoryItem.c"
}

GType
app_editor_category_item_get_type (void)
{
	static volatile gsize app_editor_category_item_type_id__volatile = 0;
	if (g_once_init_enter (&app_editor_category_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppEditorCategoryItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_editor_category_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppEditorCategoryItem), 0, (GInstanceInitFunc) app_editor_category_item_instance_init, NULL };
		static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) app_editor_category_item_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType app_editor_category_item_type_id;
		app_editor_category_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "AppEditorCategoryItem", &g_define_type_info, 0);
		g_type_add_interface_static (app_editor_category_item_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
		AppEditorCategoryItem_private_offset = g_type_add_instance_private (app_editor_category_item_type_id, sizeof (AppEditorCategoryItemPrivate));
		g_once_init_leave (&app_editor_category_item_type_id__volatile, app_editor_category_item_type_id);
	}
	return app_editor_category_item_type_id__volatile;
}

static void
_vala_app_editor_category_item_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	AppEditorCategoryItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_CATEGORY_ITEM, AppEditorCategoryItem);
#line 20 "../src/CategoryItem.vala"
	switch (property_id) {
#line 20 "../src/CategoryItem.vala"
		case APP_EDITOR_CATEGORY_ITEM_CATEGORY_PROPERTY:
#line 358 "CategoryItem.c"
		{
			AppCategory boxed;
#line 20 "../src/CategoryItem.vala"
			app_editor_category_item_get_category (self, &boxed);
#line 20 "../src/CategoryItem.vala"
			g_value_set_boxed (value, &boxed);
#line 365 "CategoryItem.c"
		}
#line 20 "../src/CategoryItem.vala"
		break;
#line 369 "CategoryItem.c"
		default:
#line 20 "../src/CategoryItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/CategoryItem.vala"
		break;
#line 375 "CategoryItem.c"
	}
}

static void
_vala_app_editor_category_item_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	AppEditorCategoryItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_CATEGORY_ITEM, AppEditorCategoryItem);
#line 20 "../src/CategoryItem.vala"
	switch (property_id) {
#line 20 "../src/CategoryItem.vala"
		case APP_EDITOR_CATEGORY_ITEM_CATEGORY_PROPERTY:
#line 20 "../src/CategoryItem.vala"
		app_editor_category_item_set_category (self, g_value_get_boxed (value));
#line 20 "../src/CategoryItem.vala"
		break;
#line 395 "CategoryItem.c"
		default:
#line 20 "../src/CategoryItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/CategoryItem.vala"
		break;
#line 401 "CategoryItem.c"
	}
}

