/* DesktopApp.c generated by valac 0.43.4, the Vala compiler
 * generated from DesktopApp.vala, do not modify */

/*-
 * Copyright (c) 2017 Adam Bieńkowski
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gee.h>

#define APP_EDITOR_TYPE_DESKTOP_APP (app_editor_desktop_app_get_type ())
#define APP_EDITOR_DESKTOP_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp))
#define APP_EDITOR_DESKTOP_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopAppClass))
#define APP_EDITOR_IS_DESKTOP_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_EDITOR_TYPE_DESKTOP_APP))
#define APP_EDITOR_IS_DESKTOP_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_EDITOR_TYPE_DESKTOP_APP))
#define APP_EDITOR_DESKTOP_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopAppClass))

typedef struct _AppEditorDesktopApp AppEditorDesktopApp;
typedef struct _AppEditorDesktopAppClass AppEditorDesktopAppClass;
typedef struct _AppEditorDesktopAppPrivate AppEditorDesktopAppPrivate;

#define TYPE_APP_CATEGORY (app_category_get_type ())
typedef struct _AppCategory AppCategory;
enum  {
	APP_EDITOR_DESKTOP_APP_0_PROPERTY,
	APP_EDITOR_DESKTOP_APP_INFO_PROPERTY,
	APP_EDITOR_DESKTOP_APP_NUM_PROPERTIES
};
static GParamSpec* app_editor_desktop_app_properties[APP_EDITOR_DESKTOP_APP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _app_category_free0(var) ((var == NULL) ? NULL : (var = (app_category_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	APP_EDITOR_DESKTOP_APP_CHANGED_SIGNAL,
	APP_EDITOR_DESKTOP_APP_NUM_SIGNALS
};
static guint app_editor_desktop_app_signals[APP_EDITOR_DESKTOP_APP_NUM_SIGNALS] = {0};

struct _AppEditorDesktopApp {
	GObject parent_instance;
	AppEditorDesktopAppPrivate * priv;
};

struct _AppEditorDesktopAppClass {
	GObjectClass parent_class;
};

struct _AppCategory {
	gchar* id;
	const gchar* name;
	gchar* icon_name;
};

struct _AppEditorDesktopAppPrivate {
	gchar* display_name;
	gchar* description;
	GIcon* icon;
	gchar* commandline;
	gchar* path;
	gchar** categories;
	gint categories_length1;
	gint _categories_size_;
	AppCategory* main_category;
	GDesktopAppInfo* _info;
};

static gint AppEditorDesktopApp_private_offset;
static gpointer app_editor_desktop_app_parent_class = NULL;
static GIcon* app_editor_desktop_app_default_icon;
static GIcon* app_editor_desktop_app_default_icon = NULL;

GType app_editor_desktop_app_get_type (void) G_GNUC_CONST;
GType app_category_get_type (void) G_GNUC_CONST;
AppCategory* app_category_dup (const AppCategory* self);
void app_category_free (AppCategory* self);
void app_category_copy (const AppCategory* self,
                        AppCategory* dest);
void app_category_destroy (AppCategory* self);
#define APP_EDITOR_DESKTOP_APP_DEFAULT_LIST_SEPARATOR ';'
#define APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_PREFIX "appeditor-local-application-"
#define APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_SUFFIX ".desktop"
#define APP_EDITOR_DESKTOP_APP_USES_NOTIFICATIONS_KEY "X-GNOME-UsesNotifications"
#define APP_EDITOR_DESKTOP_APP_DEFAULT_ICON_NAME "application-x-executable"
gboolean app_editor_desktop_app_get_name_only_local (const gchar* name);
AppEditorDesktopApp* app_editor_desktop_app_new (GDesktopAppInfo* info);
AppEditorDesktopApp* app_editor_desktop_app_construct (GType object_type,
                                                       GDesktopAppInfo* info);
void app_editor_desktop_app_open_default_handler (AppEditorDesktopApp* self,
                                                  GdkScreen* screen,
                                                  GError** error);
GDesktopAppInfo* app_editor_desktop_app_get_info (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_only_local (AppEditorDesktopApp* self);
gchar* app_editor_desktop_app_get_basename (AppEditorDesktopApp* self);
gint app_editor_app_directory_scanner_get_desktop_id_count (const gchar* desktop_id);
gboolean app_editor_desktop_app_compare (AppEditorDesktopApp* self,
                                         AppEditorDesktopApp* other);
const gchar* app_editor_desktop_app_get_display_name (AppEditorDesktopApp* self);
const gchar* app_editor_desktop_app_get_description (AppEditorDesktopApp* self);
GIcon* app_editor_desktop_app_get_icon (AppEditorDesktopApp* self);
const gchar* app_editor_desktop_app_get_commandline (AppEditorDesktopApp* self);
const gchar* app_editor_desktop_app_get_path (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_terminal (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_display (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_should_show (AppEditorDesktopApp* self);
gchar** app_editor_desktop_app_get_categories (AppEditorDesktopApp* self,
                                               gint* result_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
void app_editor_desktop_app_get_main_category (AppEditorDesktopApp* self,
                                               AppCategory* result);
GeeArrayList* app_editor_desktop_app_manager_get_menu_cateogries (void);
void app_editor_desktop_app_manager_get_default_category (AppCategory* result);
static void app_editor_desktop_app_reset_values (AppEditorDesktopApp* self);
void app_editor_desktop_app_set_info (AppEditorDesktopApp* self,
                                      GDesktopAppInfo* value);
static GObject * app_editor_desktop_app_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _app_editor_desktop_app_reset_values_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void app_editor_desktop_app_finalize (GObject * obj);
static void _vala_app_editor_desktop_app_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_app_editor_desktop_app_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
app_editor_desktop_app_get_instance_private (AppEditorDesktopApp* self)
{
	return G_STRUCT_MEMBER_P (self, AppEditorDesktopApp_private_offset);
}

gboolean
app_editor_desktop_app_get_name_only_local (const gchar* name)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 50 "../src/DesktopApp.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 51 "../src/DesktopApp.vala"
	if (g_str_has_prefix (name, APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_PREFIX)) {
#line 51 "../src/DesktopApp.vala"
		_tmp0_ = g_str_has_suffix (name, APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_SUFFIX);
#line 180 "DesktopApp.c"
	} else {
#line 51 "../src/DesktopApp.vala"
		_tmp0_ = FALSE;
#line 184 "DesktopApp.c"
	}
#line 51 "../src/DesktopApp.vala"
	result = _tmp0_;
#line 51 "../src/DesktopApp.vala"
	return result;
#line 190 "DesktopApp.c"
}

AppEditorDesktopApp*
app_editor_desktop_app_construct (GType object_type,
                                  GDesktopAppInfo* info)
{
	AppEditorDesktopApp * self = NULL;
#line 54 "../src/DesktopApp.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 55 "../src/DesktopApp.vala"
	self = (AppEditorDesktopApp*) g_object_new (object_type, "info", info, NULL);
#line 54 "../src/DesktopApp.vala"
	return self;
#line 204 "DesktopApp.c"
}

AppEditorDesktopApp*
app_editor_desktop_app_new (GDesktopAppInfo* info)
{
#line 54 "../src/DesktopApp.vala"
	return app_editor_desktop_app_construct (APP_EDITOR_TYPE_DESKTOP_APP, info);
#line 212 "DesktopApp.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 63 "../src/DesktopApp.vala"
	return self ? g_error_copy (self) : NULL;
#line 220 "DesktopApp.c"
}

void
app_editor_desktop_app_open_default_handler (AppEditorDesktopApp* self,
                                             GdkScreen* screen,
                                             GError** error)
{
	GFile* file = NULL;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GError * _inner_error_ = NULL;
#line 58 "../src/DesktopApp.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->_info;
#line 59 "../src/DesktopApp.vala"
	_tmp1_ = g_desktop_app_info_get_filename (_tmp0_);
#line 59 "../src/DesktopApp.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 59 "../src/DesktopApp.vala"
	file = _tmp2_;
#line 243 "DesktopApp.c"
	{
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 61 "../src/DesktopApp.vala"
		_tmp3_ = file;
#line 61 "../src/DesktopApp.vala"
		_tmp4_ = g_file_get_uri (_tmp3_);
#line 61 "../src/DesktopApp.vala"
		_tmp5_ = _tmp4_;
#line 61 "../src/DesktopApp.vala"
		gtk_show_uri (screen, _tmp5_, gtk_get_current_event_time (), &_inner_error_);
#line 61 "../src/DesktopApp.vala"
		_g_free0 (_tmp5_);
#line 61 "../src/DesktopApp.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 260 "DesktopApp.c"
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		GError* _tmp7_;
#line 60 "../src/DesktopApp.vala"
		e = _inner_error_;
#line 60 "../src/DesktopApp.vala"
		_inner_error_ = NULL;
#line 63 "../src/DesktopApp.vala"
		_tmp6_ = e;
#line 63 "../src/DesktopApp.vala"
		_tmp7_ = _g_error_copy0 (_tmp6_);
#line 63 "../src/DesktopApp.vala"
		_inner_error_ = _tmp7_;
#line 63 "../src/DesktopApp.vala"
		_g_error_free0 (e);
#line 282 "DesktopApp.c"
		goto __finally7;
	}
	__finally7:
#line 60 "../src/DesktopApp.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 60 "../src/DesktopApp.vala"
		g_propagate_error (error, _inner_error_);
#line 60 "../src/DesktopApp.vala"
		_g_object_unref0 (file);
#line 60 "../src/DesktopApp.vala"
		return;
#line 294 "DesktopApp.c"
	}
#line 58 "../src/DesktopApp.vala"
	_g_object_unref0 (file);
#line 298 "DesktopApp.c"
}

gboolean
app_editor_desktop_app_get_only_local (AppEditorDesktopApp* self)
{
	gboolean result = FALSE;
	gchar* basename = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 67 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 68 "../src/DesktopApp.vala"
	_tmp0_ = app_editor_desktop_app_get_basename (self);
#line 68 "../src/DesktopApp.vala"
	basename = _tmp0_;
#line 69 "../src/DesktopApp.vala"
	_tmp1_ = basename;
#line 69 "../src/DesktopApp.vala"
	if (app_editor_desktop_app_get_name_only_local (_tmp1_)) {
#line 70 "../src/DesktopApp.vala"
		result = TRUE;
#line 70 "../src/DesktopApp.vala"
		_g_free0 (basename);
#line 70 "../src/DesktopApp.vala"
		return result;
#line 325 "DesktopApp.c"
	}
#line 73 "../src/DesktopApp.vala"
	_tmp2_ = basename;
#line 73 "../src/DesktopApp.vala"
	result = app_editor_app_directory_scanner_get_desktop_id_count (_tmp2_) <= 1;
#line 73 "../src/DesktopApp.vala"
	_g_free0 (basename);
#line 73 "../src/DesktopApp.vala"
	return result;
#line 335 "DesktopApp.c"
}

gboolean
app_editor_desktop_app_compare (AppEditorDesktopApp* self,
                                AppEditorDesktopApp* other)
{
	gboolean result = FALSE;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	const gchar* _tmp3_;
#line 76 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 76 "../src/DesktopApp.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 77 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->_info;
#line 77 "../src/DesktopApp.vala"
	_tmp1_ = g_desktop_app_info_get_filename (_tmp0_);
#line 77 "../src/DesktopApp.vala"
	_tmp2_ = other->priv->_info;
#line 77 "../src/DesktopApp.vala"
	_tmp3_ = g_desktop_app_info_get_filename (_tmp2_);
#line 77 "../src/DesktopApp.vala"
	result = g_strcmp0 (_tmp1_, _tmp3_) == 0;
#line 77 "../src/DesktopApp.vala"
	return result;
#line 363 "DesktopApp.c"
}

const gchar*
app_editor_desktop_app_get_display_name (AppEditorDesktopApp* self)
{
	const gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp4_;
#line 80 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->display_name;
#line 81 "../src/DesktopApp.vala"
	if (_tmp0_ == NULL) {
#line 378 "DesktopApp.c"
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 82 "../src/DesktopApp.vala"
		_tmp1_ = self->priv->_info;
#line 82 "../src/DesktopApp.vala"
		_tmp2_ = g_app_info_get_display_name ((GAppInfo*) _tmp1_);
#line 82 "../src/DesktopApp.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 82 "../src/DesktopApp.vala"
		_g_free0 (self->priv->display_name);
#line 82 "../src/DesktopApp.vala"
		self->priv->display_name = _tmp3_;
#line 392 "DesktopApp.c"
	}
#line 85 "../src/DesktopApp.vala"
	_tmp4_ = self->priv->display_name;
#line 85 "../src/DesktopApp.vala"
	result = _tmp4_;
#line 85 "../src/DesktopApp.vala"
	return result;
#line 400 "DesktopApp.c"
}

gchar*
app_editor_desktop_app_get_basename (AppEditorDesktopApp* self)
{
	gchar* result = NULL;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 88 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->_info;
#line 89 "../src/DesktopApp.vala"
	_tmp1_ = g_desktop_app_info_get_filename (_tmp0_);
#line 89 "../src/DesktopApp.vala"
	_tmp2_ = g_path_get_basename (_tmp1_);
#line 89 "../src/DesktopApp.vala"
	result = _tmp2_;
#line 89 "../src/DesktopApp.vala"
	return result;
#line 422 "DesktopApp.c"
}

const gchar*
app_editor_desktop_app_get_description (AppEditorDesktopApp* self)
{
	const gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp6_;
#line 92 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->description;
#line 93 "../src/DesktopApp.vala"
	if (_tmp0_ == NULL) {
#line 437 "DesktopApp.c"
		const gchar* desc = NULL;
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 94 "../src/DesktopApp.vala"
		_tmp1_ = self->priv->_info;
#line 94 "../src/DesktopApp.vala"
		_tmp2_ = g_app_info_get_description ((GAppInfo*) _tmp1_);
#line 94 "../src/DesktopApp.vala"
		desc = _tmp2_;
#line 95 "../src/DesktopApp.vala"
		_tmp3_ = desc;
#line 95 "../src/DesktopApp.vala"
		if (_tmp3_ == NULL) {
#line 96 "../src/DesktopApp.vala"
			desc = "";
#line 456 "DesktopApp.c"
		}
#line 99 "../src/DesktopApp.vala"
		_tmp4_ = desc;
#line 99 "../src/DesktopApp.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 99 "../src/DesktopApp.vala"
		_g_free0 (self->priv->description);
#line 99 "../src/DesktopApp.vala"
		self->priv->description = _tmp5_;
#line 466 "DesktopApp.c"
	}
#line 102 "../src/DesktopApp.vala"
	_tmp6_ = self->priv->description;
#line 102 "../src/DesktopApp.vala"
	result = _tmp6_;
#line 102 "../src/DesktopApp.vala"
	return result;
#line 474 "DesktopApp.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 107 "../src/DesktopApp.vala"
	return self ? g_object_ref (self) : NULL;
#line 482 "DesktopApp.c"
}

GIcon*
app_editor_desktop_app_get_icon (AppEditorDesktopApp* self)
{
	GIcon* result = NULL;
	GIcon* _tmp0_;
	GIcon* _tmp9_;
	GIcon* _tmp10_;
#line 105 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->icon;
#line 106 "../src/DesktopApp.vala"
	if (_tmp0_ == NULL) {
#line 498 "DesktopApp.c"
		GIcon* _icon = NULL;
		GDesktopAppInfo* _tmp1_;
		GIcon* _tmp2_;
		GIcon* _tmp3_;
		GIcon* _tmp4_;
		GIcon* _tmp7_;
		GIcon* _tmp8_;
#line 107 "../src/DesktopApp.vala"
		_tmp1_ = self->priv->_info;
#line 107 "../src/DesktopApp.vala"
		_tmp2_ = g_app_info_get_icon ((GAppInfo*) _tmp1_);
#line 107 "../src/DesktopApp.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 107 "../src/DesktopApp.vala"
		_icon = _tmp3_;
#line 108 "../src/DesktopApp.vala"
		_tmp4_ = _icon;
#line 108 "../src/DesktopApp.vala"
		if (_tmp4_ == NULL) {
#line 518 "DesktopApp.c"
			GIcon* _tmp5_;
			GIcon* _tmp6_;
#line 109 "../src/DesktopApp.vala"
			_tmp5_ = app_editor_desktop_app_default_icon;
#line 109 "../src/DesktopApp.vala"
			_tmp6_ = _g_object_ref0 (_tmp5_);
#line 109 "../src/DesktopApp.vala"
			_g_object_unref0 (_icon);
#line 109 "../src/DesktopApp.vala"
			_icon = _tmp6_;
#line 529 "DesktopApp.c"
		}
#line 112 "../src/DesktopApp.vala"
		_tmp7_ = _icon;
#line 112 "../src/DesktopApp.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 112 "../src/DesktopApp.vala"
		_g_object_unref0 (self->priv->icon);
#line 112 "../src/DesktopApp.vala"
		self->priv->icon = _tmp8_;
#line 106 "../src/DesktopApp.vala"
		_g_object_unref0 (_icon);
#line 541 "DesktopApp.c"
	}
#line 115 "../src/DesktopApp.vala"
	_tmp9_ = self->priv->icon;
#line 115 "../src/DesktopApp.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 115 "../src/DesktopApp.vala"
	result = _tmp10_;
#line 115 "../src/DesktopApp.vala"
	return result;
#line 551 "DesktopApp.c"
}

const gchar*
app_editor_desktop_app_get_commandline (AppEditorDesktopApp* self)
{
	const gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp6_;
#line 118 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->commandline;
#line 119 "../src/DesktopApp.vala"
	if (_tmp0_ == NULL) {
#line 566 "DesktopApp.c"
		const gchar* cmdline = NULL;
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 120 "../src/DesktopApp.vala"
		_tmp1_ = self->priv->_info;
#line 120 "../src/DesktopApp.vala"
		_tmp2_ = g_app_info_get_commandline ((GAppInfo*) _tmp1_);
#line 120 "../src/DesktopApp.vala"
		cmdline = _tmp2_;
#line 121 "../src/DesktopApp.vala"
		_tmp3_ = cmdline;
#line 121 "../src/DesktopApp.vala"
		if (_tmp3_ == NULL) {
#line 122 "../src/DesktopApp.vala"
			cmdline = "";
#line 585 "DesktopApp.c"
		}
#line 125 "../src/DesktopApp.vala"
		_tmp4_ = cmdline;
#line 125 "../src/DesktopApp.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 125 "../src/DesktopApp.vala"
		_g_free0 (self->priv->commandline);
#line 125 "../src/DesktopApp.vala"
		self->priv->commandline = _tmp5_;
#line 595 "DesktopApp.c"
	}
#line 128 "../src/DesktopApp.vala"
	_tmp6_ = self->priv->commandline;
#line 128 "../src/DesktopApp.vala"
	result = _tmp6_;
#line 128 "../src/DesktopApp.vala"
	return result;
#line 603 "DesktopApp.c"
}

const gchar*
app_editor_desktop_app_get_path (AppEditorDesktopApp* self)
{
	const gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp6_;
#line 131 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->path;
#line 132 "../src/DesktopApp.vala"
	if (_tmp0_ == NULL) {
#line 618 "DesktopApp.c"
		const gchar* _path = NULL;
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 133 "../src/DesktopApp.vala"
		_tmp1_ = self->priv->_info;
#line 133 "../src/DesktopApp.vala"
		_tmp2_ = g_desktop_app_info_get_string (_tmp1_, G_KEY_FILE_DESKTOP_KEY_PATH);
#line 133 "../src/DesktopApp.vala"
		_path = _tmp2_;
#line 134 "../src/DesktopApp.vala"
		_tmp3_ = _path;
#line 134 "../src/DesktopApp.vala"
		if (_tmp3_ == NULL) {
#line 135 "../src/DesktopApp.vala"
			_path = "";
#line 637 "DesktopApp.c"
		}
#line 138 "../src/DesktopApp.vala"
		_tmp4_ = _path;
#line 138 "../src/DesktopApp.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 138 "../src/DesktopApp.vala"
		_g_free0 (self->priv->path);
#line 138 "../src/DesktopApp.vala"
		self->priv->path = _tmp5_;
#line 647 "DesktopApp.c"
	}
#line 141 "../src/DesktopApp.vala"
	_tmp6_ = self->priv->path;
#line 141 "../src/DesktopApp.vala"
	result = _tmp6_;
#line 141 "../src/DesktopApp.vala"
	return result;
#line 655 "DesktopApp.c"
}

gboolean
app_editor_desktop_app_get_terminal (AppEditorDesktopApp* self)
{
	gboolean result = FALSE;
	GDesktopAppInfo* _tmp0_;
#line 144 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->_info;
#line 145 "../src/DesktopApp.vala"
	result = g_desktop_app_info_get_boolean (_tmp0_, G_KEY_FILE_DESKTOP_KEY_TERMINAL);
#line 145 "../src/DesktopApp.vala"
	return result;
#line 671 "DesktopApp.c"
}

gboolean
app_editor_desktop_app_get_display (AppEditorDesktopApp* self)
{
	gboolean result = FALSE;
	GDesktopAppInfo* _tmp0_;
#line 148 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 149 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->_info;
#line 149 "../src/DesktopApp.vala"
	result = !g_desktop_app_info_get_nodisplay (_tmp0_);
#line 149 "../src/DesktopApp.vala"
	return result;
#line 687 "DesktopApp.c"
}

gboolean
app_editor_desktop_app_get_should_show (AppEditorDesktopApp* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GDesktopAppInfo* _tmp1_;
#line 152 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "../src/DesktopApp.vala"
	_tmp1_ = self->priv->_info;
#line 153 "../src/DesktopApp.vala"
	if (g_app_info_should_show ((GAppInfo*) _tmp1_)) {
#line 153 "../src/DesktopApp.vala"
		_tmp0_ = !app_editor_desktop_app_get_terminal (self);
#line 704 "DesktopApp.c"
	} else {
#line 153 "../src/DesktopApp.vala"
		_tmp0_ = FALSE;
#line 708 "DesktopApp.c"
	}
#line 153 "../src/DesktopApp.vala"
	result = _tmp0_;
#line 153 "../src/DesktopApp.vala"
	return result;
#line 714 "DesktopApp.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 165 "../src/DesktopApp.vala"
	result = g_new0 (gchar*, length + 1);
#line 165 "../src/DesktopApp.vala"
	for (i = 0; i < length; i++) {
#line 727 "DesktopApp.c"
		gchar* _tmp0_;
#line 165 "../src/DesktopApp.vala"
		_tmp0_ = g_strdup (self[i]);
#line 165 "../src/DesktopApp.vala"
		result[i] = _tmp0_;
#line 733 "DesktopApp.c"
	}
#line 165 "../src/DesktopApp.vala"
	return result;
#line 737 "DesktopApp.c"
}

gchar**
app_editor_desktop_app_get_categories (AppEditorDesktopApp* self,
                                       gint* result_length1)
{
	gchar** result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp12_;
	gint _tmp12__length1;
#line 156 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 157 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->categories;
#line 157 "../src/DesktopApp.vala"
	_tmp0__length1 = self->priv->categories_length1;
#line 157 "../src/DesktopApp.vala"
	if (_tmp0_ == NULL) {
#line 761 "DesktopApp.c"
		gchar** _tmp1_;
		const gchar* unparsed = NULL;
		GDesktopAppInfo* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 158 "../src/DesktopApp.vala"
		_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 158 "../src/DesktopApp.vala"
		self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
#line 158 "../src/DesktopApp.vala"
		self->priv->categories = _tmp1_;
#line 158 "../src/DesktopApp.vala"
		self->priv->categories_length1 = 0;
#line 158 "../src/DesktopApp.vala"
		self->priv->_categories_size_ = self->priv->categories_length1;
#line 159 "../src/DesktopApp.vala"
		_tmp2_ = self->priv->_info;
#line 159 "../src/DesktopApp.vala"
		_tmp3_ = g_desktop_app_info_get_categories (_tmp2_);
#line 159 "../src/DesktopApp.vala"
		unparsed = _tmp3_;
#line 160 "../src/DesktopApp.vala"
		_tmp4_ = unparsed;
#line 160 "../src/DesktopApp.vala"
		if (_tmp4_ != NULL) {
#line 787 "DesktopApp.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar** _tmp8_;
			gchar** _tmp9_;
#line 161 "../src/DesktopApp.vala"
			_tmp5_ = unparsed;
#line 161 "../src/DesktopApp.vala"
			_tmp6_ = g_strdup_printf ("%c", APP_EDITOR_DESKTOP_APP_DEFAULT_LIST_SEPARATOR);
#line 161 "../src/DesktopApp.vala"
			_tmp7_ = _tmp6_;
#line 161 "../src/DesktopApp.vala"
			_tmp9_ = _tmp8_ = g_strsplit (_tmp5_, _tmp7_, 0);
#line 161 "../src/DesktopApp.vala"
			self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
#line 161 "../src/DesktopApp.vala"
			self->priv->categories = _tmp9_;
#line 161 "../src/DesktopApp.vala"
			self->priv->categories_length1 = _vala_array_length (_tmp8_);
#line 161 "../src/DesktopApp.vala"
			self->priv->_categories_size_ = self->priv->categories_length1;
#line 161 "../src/DesktopApp.vala"
			_g_free0 (_tmp7_);
#line 811 "DesktopApp.c"
		}
	}
#line 165 "../src/DesktopApp.vala"
	_tmp10_ = self->priv->categories;
#line 165 "../src/DesktopApp.vala"
	_tmp10__length1 = self->priv->categories_length1;
#line 165 "../src/DesktopApp.vala"
	_tmp11_ = (_tmp10_ != NULL) ? _vala_array_dup1 (_tmp10_, _tmp10__length1) : ((gpointer) _tmp10_);
#line 165 "../src/DesktopApp.vala"
	_tmp11__length1 = _tmp10__length1;
#line 165 "../src/DesktopApp.vala"
	_tmp12_ = _tmp11_;
#line 165 "../src/DesktopApp.vala"
	_tmp12__length1 = _tmp11__length1;
#line 165 "../src/DesktopApp.vala"
	if (result_length1) {
#line 165 "../src/DesktopApp.vala"
		*result_length1 = _tmp12__length1;
#line 830 "DesktopApp.c"
	}
#line 165 "../src/DesktopApp.vala"
	result = _tmp12_;
#line 165 "../src/DesktopApp.vala"
	return result;
#line 836 "DesktopApp.c"
}

static gpointer
_app_category_dup0 (gpointer self)
{
#line 175 "../src/DesktopApp.vala"
	return self ? app_category_dup (self) : NULL;
#line 844 "DesktopApp.c"
}

void
app_editor_desktop_app_get_main_category (AppEditorDesktopApp* self,
                                          AppCategory* result)
{
	AppCategory* _tmp0_;
	AppCategory* _tmp21_;
	AppCategory _tmp22_ = {0};
#line 168 "../src/DesktopApp.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->main_category;
#line 169 "../src/DesktopApp.vala"
	if (_tmp0_ == NULL) {
#line 860 "DesktopApp.c"
		GeeArrayList* menu_categories = NULL;
		GeeArrayList* _tmp1_;
		gboolean found = FALSE;
		gint _tmp2_ = 0;
		gchar** _tmp3_;
		AppCategory* _tmp17_;
#line 170 "../src/DesktopApp.vala"
		_tmp1_ = app_editor_desktop_app_manager_get_menu_cateogries ();
#line 170 "../src/DesktopApp.vala"
		menu_categories = _tmp1_;
#line 171 "../src/DesktopApp.vala"
		found = FALSE;
#line 172 "../src/DesktopApp.vala"
		_tmp3_ = app_editor_desktop_app_get_categories (self, &_tmp2_);
#line 875 "DesktopApp.c"
		{
			gchar** category_collection = NULL;
			gint category_collection_length1 = 0;
			gint _category_collection_size_ = 0;
			gint category_it = 0;
#line 172 "../src/DesktopApp.vala"
			category_collection = _tmp3_;
#line 172 "../src/DesktopApp.vala"
			category_collection_length1 = _tmp2_;
#line 172 "../src/DesktopApp.vala"
			for (category_it = 0; category_it < _tmp2_; category_it = category_it + 1) {
#line 887 "DesktopApp.c"
				gchar* _tmp4_;
				gchar* category = NULL;
#line 172 "../src/DesktopApp.vala"
				_tmp4_ = g_strdup (category_collection[category_it]);
#line 172 "../src/DesktopApp.vala"
				category = _tmp4_;
#line 894 "DesktopApp.c"
				{
					{
						GeeArrayList* _menu_category_list = NULL;
						GeeArrayList* _tmp5_;
						GeeArrayList* _tmp6_;
						gint _menu_category_size = 0;
						GeeArrayList* _tmp7_;
						gint _tmp8_;
						gint _tmp9_;
						gint _menu_category_index = 0;
#line 173 "../src/DesktopApp.vala"
						_tmp5_ = menu_categories;
#line 173 "../src/DesktopApp.vala"
						_tmp6_ = _g_object_ref0 (_tmp5_);
#line 173 "../src/DesktopApp.vala"
						_menu_category_list = _tmp6_;
#line 173 "../src/DesktopApp.vala"
						_tmp7_ = _menu_category_list;
#line 173 "../src/DesktopApp.vala"
						_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 173 "../src/DesktopApp.vala"
						_tmp9_ = _tmp8_;
#line 173 "../src/DesktopApp.vala"
						_menu_category_size = _tmp9_;
#line 173 "../src/DesktopApp.vala"
						_menu_category_index = -1;
#line 173 "../src/DesktopApp.vala"
						while (TRUE) {
#line 923 "DesktopApp.c"
							AppCategory* menu_category = NULL;
							GeeArrayList* _tmp10_;
							gpointer _tmp11_;
							const gchar* _tmp12_;
							AppCategory* _tmp13_;
							const gchar* _tmp14_;
#line 173 "../src/DesktopApp.vala"
							_menu_category_index = _menu_category_index + 1;
#line 173 "../src/DesktopApp.vala"
							if (!(_menu_category_index < _menu_category_size)) {
#line 173 "../src/DesktopApp.vala"
								break;
#line 936 "DesktopApp.c"
							}
#line 173 "../src/DesktopApp.vala"
							_tmp10_ = _menu_category_list;
#line 173 "../src/DesktopApp.vala"
							_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _menu_category_index);
#line 173 "../src/DesktopApp.vala"
							menu_category = (AppCategory*) _tmp11_;
#line 174 "../src/DesktopApp.vala"
							_tmp12_ = category;
#line 174 "../src/DesktopApp.vala"
							_tmp13_ = menu_category;
#line 174 "../src/DesktopApp.vala"
							_tmp14_ = (*_tmp13_).id;
#line 174 "../src/DesktopApp.vala"
							if (g_strcmp0 (_tmp12_, _tmp14_) == 0) {
#line 952 "DesktopApp.c"
								AppCategory* _tmp15_;
								AppCategory* _tmp16_;
#line 175 "../src/DesktopApp.vala"
								_tmp15_ = menu_category;
#line 175 "../src/DesktopApp.vala"
								_tmp16_ = _app_category_dup0 (_tmp15_);
#line 175 "../src/DesktopApp.vala"
								_app_category_free0 (self->priv->main_category);
#line 175 "../src/DesktopApp.vala"
								self->priv->main_category = _tmp16_;
#line 176 "../src/DesktopApp.vala"
								found = TRUE;
#line 177 "../src/DesktopApp.vala"
								_app_category_free0 (menu_category);
#line 177 "../src/DesktopApp.vala"
								break;
#line 969 "DesktopApp.c"
							}
#line 173 "../src/DesktopApp.vala"
							_app_category_free0 (menu_category);
#line 973 "DesktopApp.c"
						}
#line 173 "../src/DesktopApp.vala"
						_g_object_unref0 (_menu_category_list);
#line 977 "DesktopApp.c"
					}
#line 181 "../src/DesktopApp.vala"
					if (found) {
#line 182 "../src/DesktopApp.vala"
						_g_free0 (category);
#line 182 "../src/DesktopApp.vala"
						break;
#line 985 "DesktopApp.c"
					}
#line 172 "../src/DesktopApp.vala"
					_g_free0 (category);
#line 989 "DesktopApp.c"
				}
			}
#line 172 "../src/DesktopApp.vala"
			category_collection = (_vala_array_free (category_collection, category_collection_length1, (GDestroyNotify) g_free), NULL);
#line 994 "DesktopApp.c"
		}
#line 186 "../src/DesktopApp.vala"
		_tmp17_ = self->priv->main_category;
#line 186 "../src/DesktopApp.vala"
		if (_tmp17_ == NULL) {
#line 1000 "DesktopApp.c"
			AppCategory _tmp18_ = {0};
			AppCategory _tmp19_;
			AppCategory* _tmp20_;
#line 187 "../src/DesktopApp.vala"
			app_editor_desktop_app_manager_get_default_category (&_tmp18_);
#line 187 "../src/DesktopApp.vala"
			_tmp19_ = _tmp18_;
#line 187 "../src/DesktopApp.vala"
			_tmp20_ = _app_category_dup0 (&_tmp19_);
#line 187 "../src/DesktopApp.vala"
			_app_category_free0 (self->priv->main_category);
#line 187 "../src/DesktopApp.vala"
			self->priv->main_category = _tmp20_;
#line 187 "../src/DesktopApp.vala"
			app_category_destroy (&_tmp19_);
#line 1016 "DesktopApp.c"
		}
#line 169 "../src/DesktopApp.vala"
		_g_object_unref0 (menu_categories);
#line 1020 "DesktopApp.c"
	}
#line 191 "../src/DesktopApp.vala"
	_tmp21_ = self->priv->main_category;
#line 191 "../src/DesktopApp.vala"
	app_category_copy (_tmp21_, &_tmp22_);
#line 191 "../src/DesktopApp.vala"
	*result = _tmp22_;
#line 191 "../src/DesktopApp.vala"
	return;
#line 1030 "DesktopApp.c"
}

static void
app_editor_desktop_app_reset_values (AppEditorDesktopApp* self)
{
#line 194 "../src/DesktopApp.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/DesktopApp.vala"
	_g_free0 (self->priv->display_name);
#line 195 "../src/DesktopApp.vala"
	self->priv->display_name = NULL;
#line 196 "../src/DesktopApp.vala"
	_g_free0 (self->priv->description);
#line 196 "../src/DesktopApp.vala"
	self->priv->description = NULL;
#line 197 "../src/DesktopApp.vala"
	_g_object_unref0 (self->priv->icon);
#line 197 "../src/DesktopApp.vala"
	self->priv->icon = NULL;
#line 198 "../src/DesktopApp.vala"
	_g_free0 (self->priv->commandline);
#line 198 "../src/DesktopApp.vala"
	self->priv->commandline = NULL;
#line 199 "../src/DesktopApp.vala"
	_g_free0 (self->priv->path);
#line 199 "../src/DesktopApp.vala"
	self->priv->path = NULL;
#line 200 "../src/DesktopApp.vala"
	self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
#line 200 "../src/DesktopApp.vala"
	self->priv->categories = NULL;
#line 200 "../src/DesktopApp.vala"
	self->priv->categories_length1 = 0;
#line 200 "../src/DesktopApp.vala"
	self->priv->_categories_size_ = self->priv->categories_length1;
#line 201 "../src/DesktopApp.vala"
	_app_category_free0 (self->priv->main_category);
#line 201 "../src/DesktopApp.vala"
	self->priv->main_category = NULL;
#line 202 "../src/DesktopApp.vala"
	g_signal_emit (self, app_editor_desktop_app_signals[APP_EDITOR_DESKTOP_APP_CHANGED_SIGNAL], 0);
#line 1072 "DesktopApp.c"
}

GDesktopAppInfo*
app_editor_desktop_app_get_info (AppEditorDesktopApp* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 38 "../src/DesktopApp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/DesktopApp.vala"
	_tmp0_ = self->priv->_info;
#line 38 "../src/DesktopApp.vala"
	result = _tmp0_;
#line 38 "../src/DesktopApp.vala"
	return result;
#line 1088 "DesktopApp.c"
}

void
app_editor_desktop_app_set_info (AppEditorDesktopApp* self,
                                 GDesktopAppInfo* value)
{
#line 38 "../src/DesktopApp.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/DesktopApp.vala"
	if (app_editor_desktop_app_get_info (self) != value) {
#line 1099 "DesktopApp.c"
		GDesktopAppInfo* _tmp0_;
#line 38 "../src/DesktopApp.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/DesktopApp.vala"
		_g_object_unref0 (self->priv->_info);
#line 38 "../src/DesktopApp.vala"
		self->priv->_info = _tmp0_;
#line 38 "../src/DesktopApp.vala"
		g_object_notify_by_pspec ((GObject *) self, app_editor_desktop_app_properties[APP_EDITOR_DESKTOP_APP_INFO_PROPERTY]);
#line 1109 "DesktopApp.c"
	}
}

static void
_app_editor_desktop_app_reset_values_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 47 "../src/DesktopApp.vala"
	app_editor_desktop_app_reset_values ((AppEditorDesktopApp*) self);
#line 1120 "DesktopApp.c"
}

static GObject *
app_editor_desktop_app_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppEditorDesktopApp * self;
#line 46 "../src/DesktopApp.vala"
	parent_class = G_OBJECT_CLASS (app_editor_desktop_app_parent_class);
#line 46 "../src/DesktopApp.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 46 "../src/DesktopApp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
#line 47 "../src/DesktopApp.vala"
	g_signal_connect_object ((GObject*) self, "notify::info", (GCallback) _app_editor_desktop_app_reset_values_g_object_notify, self, 0);
#line 46 "../src/DesktopApp.vala"
	return obj;
#line 1141 "DesktopApp.c"
}

static void
app_editor_desktop_app_class_init (AppEditorDesktopAppClass * klass,
                                   gpointer klass_data)
{
	GThemedIcon* _tmp0_;
#line 20 "../src/DesktopApp.vala"
	app_editor_desktop_app_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/DesktopApp.vala"
	g_type_class_adjust_private_offset (klass, &AppEditorDesktopApp_private_offset);
#line 20 "../src/DesktopApp.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_editor_desktop_app_get_property;
#line 20 "../src/DesktopApp.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_editor_desktop_app_set_property;
#line 20 "../src/DesktopApp.vala"
	G_OBJECT_CLASS (klass)->constructor = app_editor_desktop_app_constructor;
#line 20 "../src/DesktopApp.vala"
	G_OBJECT_CLASS (klass)->finalize = app_editor_desktop_app_finalize;
#line 20 "../src/DesktopApp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_EDITOR_DESKTOP_APP_INFO_PROPERTY, app_editor_desktop_app_properties[APP_EDITOR_DESKTOP_APP_INFO_PROPERTY] = g_param_spec_object ("info", "info", "info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 20 "../src/DesktopApp.vala"
	app_editor_desktop_app_signals[APP_EDITOR_DESKTOP_APP_CHANGED_SIGNAL] = g_signal_new ("changed", APP_EDITOR_TYPE_DESKTOP_APP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 43 "../src/DesktopApp.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (APP_EDITOR_DESKTOP_APP_DEFAULT_ICON_NAME);
#line 43 "../src/DesktopApp.vala"
	_g_object_unref0 (app_editor_desktop_app_default_icon);
#line 43 "../src/DesktopApp.vala"
	app_editor_desktop_app_default_icon = (GIcon*) _tmp0_;
#line 1171 "DesktopApp.c"
}

static void
app_editor_desktop_app_instance_init (AppEditorDesktopApp * self,
                                      gpointer klass)
{
#line 20 "../src/DesktopApp.vala"
	self->priv = app_editor_desktop_app_get_instance_private (self);
#line 30 "../src/DesktopApp.vala"
	self->priv->display_name = NULL;
#line 31 "../src/DesktopApp.vala"
	self->priv->description = NULL;
#line 32 "../src/DesktopApp.vala"
	self->priv->icon = NULL;
#line 33 "../src/DesktopApp.vala"
	self->priv->commandline = NULL;
#line 34 "../src/DesktopApp.vala"
	self->priv->path = NULL;
#line 35 "../src/DesktopApp.vala"
	self->priv->categories = NULL;
#line 35 "../src/DesktopApp.vala"
	self->priv->categories_length1 = 0;
#line 35 "../src/DesktopApp.vala"
	self->priv->_categories_size_ = self->priv->categories_length1;
#line 36 "../src/DesktopApp.vala"
	self->priv->main_category = NULL;
#line 1198 "DesktopApp.c"
}

static void
app_editor_desktop_app_finalize (GObject * obj)
{
	AppEditorDesktopApp * self;
#line 20 "../src/DesktopApp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
#line 30 "../src/DesktopApp.vala"
	_g_free0 (self->priv->display_name);
#line 31 "../src/DesktopApp.vala"
	_g_free0 (self->priv->description);
#line 32 "../src/DesktopApp.vala"
	_g_object_unref0 (self->priv->icon);
#line 33 "../src/DesktopApp.vala"
	_g_free0 (self->priv->commandline);
#line 34 "../src/DesktopApp.vala"
	_g_free0 (self->priv->path);
#line 35 "../src/DesktopApp.vala"
	self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../src/DesktopApp.vala"
	_app_category_free0 (self->priv->main_category);
#line 38 "../src/DesktopApp.vala"
	_g_object_unref0 (self->priv->_info);
#line 20 "../src/DesktopApp.vala"
	G_OBJECT_CLASS (app_editor_desktop_app_parent_class)->finalize (obj);
#line 1225 "DesktopApp.c"
}

GType
app_editor_desktop_app_get_type (void)
{
	static volatile gsize app_editor_desktop_app_type_id__volatile = 0;
	if (g_once_init_enter (&app_editor_desktop_app_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppEditorDesktopAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_editor_desktop_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppEditorDesktopApp), 0, (GInstanceInitFunc) app_editor_desktop_app_instance_init, NULL };
		GType app_editor_desktop_app_type_id;
		app_editor_desktop_app_type_id = g_type_register_static (G_TYPE_OBJECT, "AppEditorDesktopApp", &g_define_type_info, 0);
		AppEditorDesktopApp_private_offset = g_type_add_instance_private (app_editor_desktop_app_type_id, sizeof (AppEditorDesktopAppPrivate));
		g_once_init_leave (&app_editor_desktop_app_type_id__volatile, app_editor_desktop_app_type_id);
	}
	return app_editor_desktop_app_type_id__volatile;
}

static void
_vala_app_editor_desktop_app_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	AppEditorDesktopApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
#line 20 "../src/DesktopApp.vala"
	switch (property_id) {
#line 20 "../src/DesktopApp.vala"
		case APP_EDITOR_DESKTOP_APP_INFO_PROPERTY:
#line 20 "../src/DesktopApp.vala"
		g_value_set_object (value, app_editor_desktop_app_get_info (self));
#line 20 "../src/DesktopApp.vala"
		break;
#line 1258 "DesktopApp.c"
		default:
#line 20 "../src/DesktopApp.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/DesktopApp.vala"
		break;
#line 1264 "DesktopApp.c"
	}
}

static void
_vala_app_editor_desktop_app_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	AppEditorDesktopApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
#line 20 "../src/DesktopApp.vala"
	switch (property_id) {
#line 20 "../src/DesktopApp.vala"
		case APP_EDITOR_DESKTOP_APP_INFO_PROPERTY:
#line 20 "../src/DesktopApp.vala"
		app_editor_desktop_app_set_info (self, g_value_get_object (value));
#line 20 "../src/DesktopApp.vala"
		break;
#line 1284 "DesktopApp.c"
		default:
#line 20 "../src/DesktopApp.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/DesktopApp.vala"
		break;
#line 1290 "DesktopApp.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

