/* IconRow.c generated by valac 0.43.4, the Vala compiler
 * generated from IconRow.vala, do not modify */

/*-
 * Copyright (c) 2017 Adam Bieńkowski
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define APP_EDITOR_TYPE_ICON_ROW (app_editor_icon_row_get_type ())
#define APP_EDITOR_ICON_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_EDITOR_TYPE_ICON_ROW, AppEditorIconRow))
#define APP_EDITOR_ICON_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_EDITOR_TYPE_ICON_ROW, AppEditorIconRowClass))
#define APP_EDITOR_IS_ICON_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_EDITOR_TYPE_ICON_ROW))
#define APP_EDITOR_IS_ICON_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_EDITOR_TYPE_ICON_ROW))
#define APP_EDITOR_ICON_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_EDITOR_TYPE_ICON_ROW, AppEditorIconRowClass))

typedef struct _AppEditorIconRow AppEditorIconRow;
typedef struct _AppEditorIconRowClass AppEditorIconRowClass;
typedef struct _AppEditorIconRowPrivate AppEditorIconRowPrivate;
enum  {
	APP_EDITOR_ICON_ROW_0_PROPERTY,
	APP_EDITOR_ICON_ROW_ICON_NAME_PROPERTY,
	APP_EDITOR_ICON_ROW_NUM_PROPERTIES
};
static GParamSpec* app_editor_icon_row_properties[APP_EDITOR_ICON_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AppEditorIconRow {
	GtkListBoxRow parent_instance;
	AppEditorIconRowPrivate * priv;
};

struct _AppEditorIconRowClass {
	GtkListBoxRowClass parent_class;
};

struct _AppEditorIconRowPrivate {
	gchar* _icon_name;
};

static gint AppEditorIconRow_private_offset;
static gpointer app_editor_icon_row_parent_class = NULL;

GType app_editor_icon_row_get_type (void) G_GNUC_CONST;
AppEditorIconRow* app_editor_icon_row_new (const gchar* icon_name);
AppEditorIconRow* app_editor_icon_row_construct (GType object_type,
                                                 const gchar* icon_name);
const gchar* app_editor_icon_row_get_icon_name (AppEditorIconRow* self);
static void app_editor_icon_row_set_icon_name (AppEditorIconRow* self,
                                        const gchar* value);
static GObject * app_editor_icon_row_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void app_editor_icon_row_finalize (GObject * obj);
static void _vala_app_editor_icon_row_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_app_editor_icon_row_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
app_editor_icon_row_get_instance_private (AppEditorIconRow* self)
{
	return G_STRUCT_MEMBER_P (self, AppEditorIconRow_private_offset);
}

AppEditorIconRow*
app_editor_icon_row_construct (GType object_type,
                               const gchar* icon_name)
{
	AppEditorIconRow * self = NULL;
#line 38 "../src/IconRow.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 39 "../src/IconRow.vala"
	self = (AppEditorIconRow*) g_object_new (object_type, "icon-name", icon_name, NULL);
#line 38 "../src/IconRow.vala"
	return self;
#line 102 "IconRow.c"
}

AppEditorIconRow*
app_editor_icon_row_new (const gchar* icon_name)
{
#line 38 "../src/IconRow.vala"
	return app_editor_icon_row_construct (APP_EDITOR_TYPE_ICON_ROW, icon_name);
#line 110 "IconRow.c"
}

const gchar*
app_editor_icon_row_get_icon_name (AppEditorIconRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 21 "../src/IconRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/IconRow.vala"
	_tmp0_ = self->priv->_icon_name;
#line 21 "../src/IconRow.vala"
	result = _tmp0_;
#line 21 "../src/IconRow.vala"
	return result;
#line 126 "IconRow.c"
}

static void
app_editor_icon_row_set_icon_name (AppEditorIconRow* self,
                                   const gchar* value)
{
#line 21 "../src/IconRow.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/IconRow.vala"
	if (g_strcmp0 (value, app_editor_icon_row_get_icon_name (self)) != 0) {
#line 137 "IconRow.c"
		gchar* _tmp0_;
#line 21 "../src/IconRow.vala"
		_tmp0_ = g_strdup (value);
#line 21 "../src/IconRow.vala"
		_g_free0 (self->priv->_icon_name);
#line 21 "../src/IconRow.vala"
		self->priv->_icon_name = _tmp0_;
#line 21 "../src/IconRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_editor_icon_row_properties[APP_EDITOR_ICON_ROW_ICON_NAME_PROPERTY]);
#line 147 "IconRow.c"
	}
}

static GObject *
app_editor_icon_row_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppEditorIconRow * self;
	GtkImage* image = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkLabel* label = NULL;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp5_;
	GtkGrid* _tmp6_;
	GtkGrid* _tmp7_;
	GtkGrid* _tmp8_;
	GtkImage* _tmp9_;
	GtkGrid* _tmp10_;
	GtkLabel* _tmp11_;
	GtkGrid* _tmp12_;
#line 23 "../src/IconRow.vala"
	parent_class = G_OBJECT_CLASS (app_editor_icon_row_parent_class);
#line 23 "../src/IconRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 23 "../src/IconRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_EDITOR_TYPE_ICON_ROW, AppEditorIconRow);
#line 24 "../src/IconRow.vala"
	_tmp0_ = self->priv->_icon_name;
#line 24 "../src/IconRow.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 24 "../src/IconRow.vala"
	g_object_ref_sink (_tmp1_);
#line 24 "../src/IconRow.vala"
	image = _tmp1_;
#line 25 "../src/IconRow.vala"
	_tmp2_ = image;
#line 25 "../src/IconRow.vala"
	gtk_image_set_pixel_size (_tmp2_, 24);
#line 27 "../src/IconRow.vala"
	_tmp3_ = self->priv->_icon_name;
#line 27 "../src/IconRow.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
#line 27 "../src/IconRow.vala"
	g_object_ref_sink (_tmp4_);
#line 27 "../src/IconRow.vala"
	label = _tmp4_;
#line 29 "../src/IconRow.vala"
	_tmp5_ = (GtkGrid*) gtk_grid_new ();
#line 29 "../src/IconRow.vala"
	g_object_ref_sink (_tmp5_);
#line 29 "../src/IconRow.vala"
	grid = _tmp5_;
#line 30 "../src/IconRow.vala"
	_tmp6_ = grid;
#line 30 "../src/IconRow.vala"
	g_object_set ((GtkWidget*) _tmp6_, "margin", 6, NULL);
#line 31 "../src/IconRow.vala"
	_tmp7_ = grid;
#line 31 "../src/IconRow.vala"
	gtk_grid_set_column_spacing (_tmp7_, 12);
#line 32 "../src/IconRow.vala"
	_tmp8_ = grid;
#line 32 "../src/IconRow.vala"
	_tmp9_ = image;
#line 32 "../src/IconRow.vala"
	gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, 0, 0, 1, 1);
#line 33 "../src/IconRow.vala"
	_tmp10_ = grid;
#line 33 "../src/IconRow.vala"
	_tmp11_ = label;
#line 33 "../src/IconRow.vala"
	gtk_grid_attach (_tmp10_, (GtkWidget*) _tmp11_, 1, 0, 1, 1);
#line 35 "../src/IconRow.vala"
	_tmp12_ = grid;
#line 35 "../src/IconRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
#line 23 "../src/IconRow.vala"
	_g_object_unref0 (grid);
#line 23 "../src/IconRow.vala"
	_g_object_unref0 (label);
#line 23 "../src/IconRow.vala"
	_g_object_unref0 (image);
#line 23 "../src/IconRow.vala"
	return obj;
#line 239 "IconRow.c"
}

static void
app_editor_icon_row_class_init (AppEditorIconRowClass * klass,
                                gpointer klass_data)
{
#line 20 "../src/IconRow.vala"
	app_editor_icon_row_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/IconRow.vala"
	g_type_class_adjust_private_offset (klass, &AppEditorIconRow_private_offset);
#line 20 "../src/IconRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_editor_icon_row_get_property;
#line 20 "../src/IconRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_editor_icon_row_set_property;
#line 20 "../src/IconRow.vala"
	G_OBJECT_CLASS (klass)->constructor = app_editor_icon_row_constructor;
#line 20 "../src/IconRow.vala"
	G_OBJECT_CLASS (klass)->finalize = app_editor_icon_row_finalize;
#line 20 "../src/IconRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_EDITOR_ICON_ROW_ICON_NAME_PROPERTY, app_editor_icon_row_properties[APP_EDITOR_ICON_ROW_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 260 "IconRow.c"
}

static void
app_editor_icon_row_instance_init (AppEditorIconRow * self,
                                   gpointer klass)
{
#line 20 "../src/IconRow.vala"
	self->priv = app_editor_icon_row_get_instance_private (self);
#line 269 "IconRow.c"
}

static void
app_editor_icon_row_finalize (GObject * obj)
{
	AppEditorIconRow * self;
#line 20 "../src/IconRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_EDITOR_TYPE_ICON_ROW, AppEditorIconRow);
#line 21 "../src/IconRow.vala"
	_g_free0 (self->priv->_icon_name);
#line 20 "../src/IconRow.vala"
	G_OBJECT_CLASS (app_editor_icon_row_parent_class)->finalize (obj);
#line 282 "IconRow.c"
}

GType
app_editor_icon_row_get_type (void)
{
	static volatile gsize app_editor_icon_row_type_id__volatile = 0;
	if (g_once_init_enter (&app_editor_icon_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppEditorIconRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_editor_icon_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppEditorIconRow), 0, (GInstanceInitFunc) app_editor_icon_row_instance_init, NULL };
		GType app_editor_icon_row_type_id;
		app_editor_icon_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "AppEditorIconRow", &g_define_type_info, 0);
		AppEditorIconRow_private_offset = g_type_add_instance_private (app_editor_icon_row_type_id, sizeof (AppEditorIconRowPrivate));
		g_once_init_leave (&app_editor_icon_row_type_id__volatile, app_editor_icon_row_type_id);
	}
	return app_editor_icon_row_type_id__volatile;
}

static void
_vala_app_editor_icon_row_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	AppEditorIconRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_ICON_ROW, AppEditorIconRow);
#line 20 "../src/IconRow.vala"
	switch (property_id) {
#line 20 "../src/IconRow.vala"
		case APP_EDITOR_ICON_ROW_ICON_NAME_PROPERTY:
#line 20 "../src/IconRow.vala"
		g_value_set_string (value, app_editor_icon_row_get_icon_name (self));
#line 20 "../src/IconRow.vala"
		break;
#line 315 "IconRow.c"
		default:
#line 20 "../src/IconRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/IconRow.vala"
		break;
#line 321 "IconRow.c"
	}
}

static void
_vala_app_editor_icon_row_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	AppEditorIconRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_ICON_ROW, AppEditorIconRow);
#line 20 "../src/IconRow.vala"
	switch (property_id) {
#line 20 "../src/IconRow.vala"
		case APP_EDITOR_ICON_ROW_ICON_NAME_PROPERTY:
#line 20 "../src/IconRow.vala"
		app_editor_icon_row_set_icon_name (self, g_value_get_string (value));
#line 20 "../src/IconRow.vala"
		break;
#line 341 "IconRow.c"
		default:
#line 20 "../src/IconRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/IconRow.vala"
		break;
#line 347 "IconRow.c"
	}
}

